unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TMainForm = class(TForm)
    DIOEdit3: TEdit;
    ReadButton: TButton;
    WriteButton: TButton;
    StatusLabel: TLabel;
    DIOEdit2: TEdit;
    DIOEdit1: TEdit;
    DIOEdit0: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure ReadButtonClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure WriteButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses
  WinUSB;

var
  hDevice: THandle = 0;
  hFile: THandle = 0;

procedure TMainForm.FormCreate(Sender: TObject);
var
  SN: array[Byte] of Int64;
  L: LongWord;

begin
  L := AWU_ListDevices(@SN[0], Length(SN));
  if L = 0 then begin
    //No devices found. Note that devices open in another app won't be found.

    hDevice := 0;
  end
  else if L = 1 then begin
    hDevice := AWU_OpenDevice(SN[0], @hFile);
  end
  else begin
    //Multiple devices found.

    //We'll just grab the first one.
    hDevice := AWU_OpenDevice(SN[0], @hFile);
  end;
end;

procedure TMainForm.ReadButtonClick(Sender: TObject);
var
  DIOData: array[0..3] of Byte;
  Status: LongWord;

begin
  Status := AWU_DIO_Read(hDevice, Length(DIOData), @DIOData[0]);
  if Status = ERROR_SUCCESS then
    StatusLabel.Caption := ''
  else
    StatusLabel.Caption := 'Error ' + IntToStr(Status)
  ;

  DIOEdit0.Text := IntToHex(DIOData[0], 2);
  DIOEdit1.Text := IntToHex(DIOData[1], 2);
  DIOEdit2.Text := IntToHex(DIOData[2], 2);
  DIOEdit3.Text := IntToHex(DIOData[3], 2);
end;

procedure TMainForm.WriteButtonClick(Sender: TObject);
var
  DIOData: array[0..3] of Byte;
  Status: LongWord;

begin
  DIOData[0] := StrToInt('$' + DIOEdit0.Text);
  DIOData[1] := StrToInt('$' + DIOEdit1.Text);
  DIOData[2] := StrToInt('$' + DIOEdit2.Text);
  DIOData[3] := StrToInt('$' + DIOEdit3.Text);

  Status := AWU_DIO_Write(hDevice, Length(DIOData), @DIOData[0]);
  if Status = ERROR_SUCCESS then
    StatusLabel.Caption := ''
  else
    StatusLabel.Caption := 'Error ' + IntToStr(Status)
  ;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  AWU_CloseDevice(hDevice, hFile);
end;

end.
